/*
 
	Created by WilliamK @ Wusik Dot Com (c) 2010
	http://arduino.wusik.com

*/

#include <Encoder1.h>

Encoder1 myEncoder = Encoder1(20,19,21);
float newData = 0.0f;

void EncoderMoveInterrupt() { myEncoder.lowLevelTick(); }
void EncoderClickInterrupt() { myEncoder.lowLevelClick(); }

void setup() 
{
  Serial.begin(38400);
  
  attachInterrupt(4,EncoderMoveInterrupt,CHANGE);
  attachInterrupt(3,EncoderMoveInterrupt,CHANGE);  
  attachInterrupt(2,EncoderClickInterrupt,CHANGE);  
  
  myEncoder.setMinMax(1,100);
  myEncoder.setPosition(50);
  myEncoder.setRate(0.25f));
  myEncoder.setIntegerMode(true);
}

void loop() 
{
  if (myEncoder.hasChanged())
  {
    newData = myEncoder.getPosition();
    Serial.print("> Position: ");
    Serial.println(newData);
  }
  if (myEncoder.hasClick()) Serial.println("! Click !");
  if (myEncoder.onClickHold()) { Serial.println(" ... Holding ..."); delay(500); }
}
